#ifndef __CPOSITION_H__
#define __CPOSITION_H__

#include "Entity.h"
#include "CBase.h"
#include "FDataTypes.h"

class CPosition : public CBase
{
public:
	class PropertyFlag : public CBase::PropertyFlag
	{
	public:
		enum
		{
			PFLAG_POSITION = CBase::PropertyFlag::NUM_OF_CBASE_PROPERTY_FLAG,
			NUM_OF_CPOSITION_PROPERTY_FLAG
		};
	};

	enum COMMAND
	{
		MOVE_LEFT = 0,
		MOVE_RIGHT,
		MOVE_UP,
		MOVE_DOWN
	};

	static CPosition* addComponentTo(Entity* object, int initPosX, int initPosY);
	
	// CPosition.h
	virtual ComponentProperty getProperty(int propertyFlag);
	virtual int	setProperty(ComponentProperty propertyData, int propertyFlag) throw(ComponentProperty::InvalidPointerType);

protected:
	CPosition();
	~CPosition();

protected:
	Vector2 m_position;
};

#endif // __CPOSITION_H__
