#include "stdafx.h"
#include "FWindows.h"
#include "FTexture.h"

#include "Entity.h"
#include "CAnimation.h"
#include "CPosition.h"
#include "CController.h"

void init(HINSTANCE instance, HWND handler);
void release();
void update(float delta);
void draw(HDC hdc);

Entity* g_entity;

int APIENTRY _tWinMain(_In_ HINSTANCE hInstance,
	_In_opt_ HINSTANCE hPrevInstance,
	_In_ LPTSTR    lpCmdLine,
	_In_ int       nCmdShow)
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);
	FWindows window(hInstance, nCmdShow, 500, 500, &update, &draw);

	init(hInstance, window.getHandler());

	window.run();
	
	release();

	return 0;
}

// main.cpp
// UPDATE REGION
void update(float delta)
{
	g_entity->update(delta);
}

// DRAW REGION
void draw(HDC hdc)
{
	g_entity->draw(hdc);
}

// main.cpp
void init(HINSTANCE instance, HWND handler)
{
	FTexture::init(instance, handler);

	g_entity = new Entity();
	CAnimation::addComponentTo(g_entity, "Resource\\logo.bmp");
	CPosition::addComponentTo(g_entity, 50, 50);
	auto controller = CController::addComponentTo(g_entity);

	g_entity->settingReact(Entity::ReactCommand(Entity::COMMAND::HIDE, ID::COMPONENT::ANIMATION, CAnimation::COMMAND::HIDE));
	g_entity->settingReact(Entity::ReactCommand(Entity::COMMAND::SHOW, ID::COMPONENT::ANIMATION, CAnimation::COMMAND::SHOW));
	g_entity->settingReact(Entity::ReactFunction(Entity::SHOW, [](Entity* entity)
	{
		ComponentProperty newPos(new Vector2(rand() % 400 + 50, rand() % 400 + 50), ComponentProperty::Type::PTYPE_VECTOR2, true);
		entity->setProperty(ID::COMPONENT::POSITION, newPos, CPosition::PropertyFlag::PFLAG_POSITION);
	}
	));

	controller->addKey('S', Entity::COMMAND::SHOW);
	controller->addKey('H', Entity::COMMAND::HIDE);
}

void release()
{
	FTexture::release();

	delete(g_entity);
}
